/*
 * IODevice.hpp
 *
 *  Created on: Oct 26, 2011
 *      Author: Andygongyb
 */

#ifndef PERIPHERAL_HPP_
#define PERIPHERAL_HPP_

#include <stdint.h>

#include "Exception.hpp"

typedef class CIDevice {
public:
	virtual uint32_t get(void) = 0;
	virtual CIDevice& operator >>(uint32_t &data) = 0;

	virtual ~CIDevice(void) {
		//
	}

}*pCIDevice;

typedef class CODevice {
public:
	virtual void put(uint32_t data) = 0;
	virtual CODevice& operator <<(uint32_t data) = 0;
	virtual CODevice& operator <<(const char *str) = 0;

	virtual ~CODevice(void) {
		//
	}

}*pCODevice;

typedef class CIODevice: public CIDevice, public CODevice {
public:

	virtual ~CIODevice(void) {
		//
	}

}*pCIODevice;

#endif /* PERIPHERAL_HPP_ */
