/*
 * Slave.hpp
 *
 * Created: 2012/4/19 2:38:33
 *  Author: Andygongyb
 */ 


#ifndef SLAVE_HPP_
#define SLAVE_HPP_

#include "TWI_ASYN.hpp"

class COmniDir;

typedef class CSlave: public CTWIM_device {
	static const uint8_t ADDR_BASE;
	
	typedef enum {
		NO_CMD = 0x00,
		SET_WHEEL = 0x01,
		SET_WORM = 0x02,
		SET_SERVO = 0x03,
		SET_SERVO_PRO = 0x04,
		SET_ADC_THR = 0x05,
		WORM_BREAK = 0x06,
		WHEEL_BREAK = 0x07,
		SET_WHEEL_PID = 0x08,
		GET_WHEEL_SPEED = 0xFE,
		GET_ADC = 0xFF
	} cmd_t;
	
	uint16_t m_pos_thr_h;
	uint16_t m_pos_thr_l;
	int8_t m_pid_set;
	
public:
	CSlave(uint8_t addr);
	
	void set_servo(int16_t pos);
	void set_servo_pro(uint8_t left, uint8_t length);
	
	void set_wheel(int16_t speed);
	void wheel_break(void);
	uint16_t get_wheel_speed(void);
	void set_wheel_pid(int8_t pid_set);
	
	void set_worm(int16_t speed);
	void worm_break(void);
	
	uint16_t get_adc(void);
	void set_adc_thr(uint16_t l_thr, uint16_t h_thr);

	friend class COmniDir;
} *pCSlave;



#endif /* SLAVE_HPP_ */