/*
 * wheel.h
 *
 * Created: 2012/4/17 16:10:12
 *  Author: Andygongyb
 */ 


#ifndef WHEEL_H_
#define WHEEL_H_

#include <stdint.h>

#define WHEEL_IN0 PD7
#define WHEEL_DDR_IN0 DDRD
#define WHEEL_PORT_IN0 PORTD
#define SET_WHEEL_IN0 WHEEL_PORT_IN0 |= _BV(WHEEL_IN0)
#define CLR_WHEEL_IN0 WHEEL_PORT_IN0 &= ~_BV(WHEEL_IN0)

#define WHEEL_IN1 PB0
#define WHEEL_DDR_IN1 DDRB
#define WHEEL_PORT_IN1 PORTB
#define SET_WHEEL_IN1 WHEEL_PORT_IN1 |= _BV(WHEEL_IN1)
#define CLR_WHEEL_IN1 WHEEL_PORT_IN1 &= ~_BV(WHEEL_IN1)

void wheel_init(void);

void wheel_set(int16_t speed);

void wheel_pid_set(int8_t speed);

void wheel_break(void);

uint16_t wheel_get_counter(void);

#endif /* WHEEL_H_ */