/*
 * Initialization.hpp
 *
 *  Created on: Nov 27, 2011
 *      Author: Andygongyb
 */

#ifndef INITIALIZATION_HPP_
#define INITIALIZATION_HPP_

#include <avr/io.h>
#include <stdint.h>
#include "Utility.hpp"

typedef class CInit {
public:

	typedef enum {

		DIV1 = 0,
		DIV2 = 1,
		DIV4 = 2,
		DIV8 = 3,
		DIV16 = 4,
		DIV32 = 5,
		DIV64 = 6,
		DIV128 = 7,
		DIV256 = 8,

	} divider_t;

private:

	static CInit *m_instance;

	CInit(void) {
		change_divider(DIV1);
	}

public:

	void change_divider(divider_t divider);

	void pll(bool if_on) {

		if (if_on) {
			// PLL at 96MHz, postscaled to 48MHz for USB and 64MHz for HS timer
			PLLFRQ = _BV(PLLUSB) | _BV(PLLTM1) | _BV(PDIV3) | _BV(PDIV1);

			// enable PLL with 16MHz input
			PLLCSR = _BV(PINDIV) | _BV(PLLE);
			// wait for PLL to lock
			loop_until_bit_is_set(PLLCSR, PLOCK);
		} else {
			PLLCSR = 0;
		}
	}

	static CInit *instance(void) {
		if (m_instance == NULL) {
			m_instance = new CInit();
		}

		return m_instance;
	}

	~CInit(void) {
		m_instance = NULL;
	}

}*pInit;

#endif /* INITIALIZATION_HPP_ */
