/*
 * SPI.cpp
 *
 *  Created on: Nov 27, 2011
 *      Author: Andygongyb
 */

#include "SPI.hpp"

CSPI::property_t CSPI::m_property = { D8, MSB, RISING, LEADING };

void CSPI::init(divider_t scaler, order_t order, polarity_t polarity,
		phase_t phase) {
	portENTER_CRITICAL();
	PORTB |= _BV(PB1) | _BV(PB2) | _BV(PB3);
	DDRB |= _BV(PB1) | _BV(PB2);
	DDRB &= ~_BV(PB3);
	SPCR = _BV(MSTR) | static_cast<uint8_t> (order)
			| static_cast<uint8_t> (polarity)
			| static_cast<uint8_t> (phase)
			| ((static_cast<uint8_t> (scaler)) >> 1); // set parameters
	SPSR = (static_cast<uint8_t> (scaler)) & 0x01; // might enter 2X speed mode
	SPCR |= _BV(SPE); // enable the SPI
	portEXIT_CRITICAL();
	m_property.scaler = scaler;
	m_property.order = order;
	m_property.polarity = polarity;
	m_property.phase = phase;
}

void CSPIDevice::init(io_set *set) {
	if (set) {
		portENTER_CRITICAL();
		m_port = set->port;
		m_pin = _BV(set->pin_no); // change to bit value
		*(set->ddr) |= m_pin; // initially output high level
		*m_port |= m_pin;
		portEXIT_CRITICAL()
		;
	}
}
