/*
 * Command.cpp
 *
 * Created: 2012/4/23 18:43:15
 *  Author: Andygongyb
 */ 

#include "Command.hpp"

 CCommand::susp_ctrl_t CCommand::execute_cmd(uint8_t* buffer) {
	if ((buffer[0] == 0xFF) && (buffer[1] == 0xFF) && (buffer[2] == 0xFF) && (buffer[3] == 0xFF)) {
		int16_t tmp = (((int16_t) buffer[6]) << 8) | buffer[5];
		switch (buffer[4]) {
		case FORWARD:
			sprintf(m_str, "forward %d", tmp);
			m_omni->move_pid((int8_t) tmp);
			break;
		case BACKWARD:
			sprintf(m_str, "backward %d", tmp);
			m_omni->move_pid((int8_t)(-tmp));
			break;
		case LEFT:
			sprintf(m_str, "left %d", tmp);
			m_omni->set_dir(-(tmp * 4));
			break;
		case RIGHT:
			sprintf(m_str, "right %d", tmp);
			m_omni->set_dir(tmp * 4);
			break;
		case SUSP:
			if (tmp == 0) {
				sprintf(m_str, "disable suspension");
				return DISABLE_SUSP;
			}
			sprintf(m_str, "enable suspension");
			return ENABLE_SUSP;
		case STOP:
			sprintf(m_str, "stop");
			m_omni->wheel_break();
			break;
		default:
			sprintf(m_str, "wrong cmd");
			break;
		}
	} else {
		sprintf(m_str, "wrong pack");
	}
	return NO_CHANGE;
}

uint8_t CCommand::copy_cmd(char* str) {
	strcpy(str, m_str);
	return strlen(m_str);
}