/*
 * Initialization.cpp
 *
 *  Created on: Apr 9, 2011
 *      Author: Andygongyb
 */

#include "Initialization.hpp"

using namespace init_names;

CInit *CInit::m_instance = NULL;

CInit::CInit(void) {

	AVR32_ENTER_CRITICAL_REGION();

	union {
		uint32_t ui;
		avr32_scif_oscctrl_t str;
	} temp_oscctrl = { 0 };
	temp_oscctrl.str.startup = AVR32_SCIF_OSCCTRL0_STARTUP_2048_RCOSC;
	temp_oscctrl.str.agc = 1;
	temp_oscctrl.str.gain = 2;
	temp_oscctrl.str.oscen = 1;
	AVR32_SCIF.unlock = AVR32_SCIF_OSCCTRL | (AVR32_SCIF_UNLOCK_KEY_VALUE
			<< AVR32_SCIF_UNLOCK_KEY_OFFSET);
	AVR32_SCIF.oscctrl[0] = temp_oscctrl.ui;
	do {
	} while (!AVR32_SCIF.PCLKSR.osc0rdy);

	union {
		uint32_t ui;
		avr32_scif_pll_t str;
	} temp_pll = { 0 };
	temp_pll.str.pllmul = 10;
	temp_pll.str.plldiv = 1;
	temp_pll.str.pllopt = 3;
	temp_pll.str.pllen = 1;

	AVR32_SCIF.unlock = AVR32_SCIF_PLL | (AVR32_SCIF_UNLOCK_KEY_VALUE
			<< AVR32_SCIF_UNLOCK_KEY_OFFSET);
	AVR32_SCIF.pll[0] = temp_pll.ui;
	do {
	} while (!AVR32_SCIF.PCLKSR.pll0_lock);

	do {
	} while (!AVR32_PM.SR.ckrdy);
	AVR32_PM.unlock = AVR32_PM_PBASEL | (AVR32_PM_UNLOCK_KEY_VALUE
			<< AVR32_PM_UNLOCK_KEY_OFFSET);
	AVR32_PM.pbasel = 1 << 7;

	do {
	} while (!AVR32_PM.SR.ckrdy);
	AVR32_PM.unlock = AVR32_PM_PBBSEL | (AVR32_PM_UNLOCK_KEY_VALUE
			<< AVR32_PM_UNLOCK_KEY_OFFSET);
	AVR32_PM.pbbsel = 1 << 7;

	do {
	} while (!AVR32_PM.SR.ckrdy);
	AVR32_PM.unlock = AVR32_PM_PBCSEL | (AVR32_PM_UNLOCK_KEY_VALUE
			<< AVR32_PM_UNLOCK_KEY_OFFSET);
	AVR32_PM.pbcsel = 1 << 7;

	AVR32_FLASHC.FCR.fws = 1;

	do {
	} while (!AVR32_PM.SR.ckrdy);
	AVR32_PM.unlock = AVR32_PM_MCCTRL | (AVR32_PM_UNLOCK_KEY_VALUE
			<< AVR32_PM_UNLOCK_KEY_OFFSET);
	AVR32_PM.mcctrl = AVR32_PM_MCCTRL_MCSEL_PLL0;

	AVR32_LEAVE_CRITICAL_REGION();

	INTC_init_interrupts(); // initialize the interrupt controller
	gpio_local_init(); // initialize local bus for GPIOs
	delay_init(66000000); // initialize delay function

}

