/*
 * ECE445_wireless.cpp
 *
 * Created: 2012/4/22 15:38:41
 *  Author: Andygongyb
 */ 

#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include "Wireless2.4GHz.hpp"
#include "Initialization.hpp"
#include "USB_CDC.hpp"
#include "Utility.hpp"

int main(void) {

	wdt_enable(WDTO_2S);

	PORTB |= _BV(PB0);
	DDRB |= _BV(PB0);

	CInit::instance();

	sei();

	CWireless *the_wireless = CWireless::instance();
	CUSB_CDC *usb = CUSB_CDC::instance();
	usb->pwr(true);

	uint8_t buffer[32];
	uint8_t rx_buffer[32];
	uint8_t rx_count;
	uint8_t len, remain;
	while (1) {
		wdt_reset();

		len = the_wireless->next_len();
		remain = 64;

		if (usb->ready_to_send() && len) {

			PORTB &= ~_BV(PB0);

			while (len && (remain >= len)) {
				the_wireless->get(buffer);
				remain = usb->write_bank(buffer, len);
				len = the_wireless->next_len();
				rx_count = usb->read_bank(rx_buffer);
				if (rx_count) {
					the_wireless->append(rx_buffer, rx_count);
				}
			}

			usb->send();
			PORTB |= _BV(PB0);
		}
		
		rx_count = usb->read_bank(rx_buffer);
		if (rx_count) {
			the_wireless->append(rx_buffer, rx_count);
		}
	}
	return 0;
}